.386 
.model 			flat, stdcall 
	option 	 	casemap :none
	include 	WBThread.inc	
	
.code
start:
	invoke 		GetModuleHandle, NULL	 
	mov 		hInstance, eax 
	invoke 		WinMain, hInstance, NULL, NULL, SW_SHOWDEFAULT
	invoke 		CoUninitialize  
	invoke 		ExitProcess, eax 


WinMain 		proc hInst :HINSTANCE, hPrevInst :HINSTANCE, CmdLine :LPSTR, CmdShow :DWORD 

	LOCAL 		wc :WNDCLASSEX 
	LOCAL		msg :MSG 

	mov   		wc.cbSize, SIZEOF WNDCLASSEX 
	mov   		wc.style, 0 
	mov   		wc.lpfnWndProc, OFFSET WinMainMsg 
	mov   		wc.cbClsExtra, NULL 
	mov   		wc.cbWndExtra, NULL 
	push  		hInstance
	pop   		wc.hInstance 
	mov   		wc.hbrBackground, COLOR_ACTIVECAPTION+1 
	mov   		wc.lpszMenuName,	NULL 
	mov   		wc.lpszClassName, offset szClassMain
	invoke 		LoadIcon,	NULL, IDI_APPLICATION 
	mov   		wc.hIcon, eax 
	mov   		wc.hIconSm, eax  
	invoke 		LoadCursor, NULL, IDC_ARROW
	mov   		wc.hCursor, eax 
	invoke 		RegisterClassEx, addr wc 
	
	invoke 		CreateWindowEx, NULL, addr szClassMain, addr szAppName,\ 
                WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE,\
                100, 100, 800, 600, NULL, NULL, hInst, NULL	
	mov    		hWinMain, eax	
	
	invoke		CreateThread, 0, 0, offset ThreadWB, 0, 0, addr IDT_WB
	mov			hThread,eax
	invoke 		SetThreadPriority, eax, THREAD_PRIORITY_ABOVE_NORMAL	
	
	.while TRUE                                                        
		invoke 	GetMessage, addr msg, NULL, 0, 0 
		.break .if (!eax) 
		invoke 	TranslateMessage, addr msg 
		invoke	DispatchMessage, addr msg 
	.ENDW 
	mov     	eax, msg.wParam   
	ret 
	
WinMain endp 



WinMainMsg 		proc hWnd :HWND, uMsg :UINT, wParam :WPARAM, lParam :LPARAM
	LOCAL		msg :MSG 
	LOCAL		uExit:DWORD	

	.if uMsg==WM_DESTROY		
		invoke 	PostQuitMessage, NULL		
	.elseif uMsg==WM_CLOSE
		invoke PostThreadMessage,IDT_WB,WM_QUIT,0,0
		mov		uExit,STILL_ACTIVE
		.while uExit==STILL_ACTIVE
			invoke GetExitCodeThread,hThread,addr uExit
			invoke 	GetMessage, addr msg, NULL, 0, 0 
			invoke 	TranslateMessage, addr msg 
			invoke	DispatchMessage, addr msg 
			invoke Sleep,10
		.endw
		invoke	CloseHandle,hThread
		jmp		ExDef
	.else
ExDef:
		invoke 	DefWindowProc, hWnd, uMsg, wParam, lParam     
		ret 			
	.endif
	ret 
	
WinMainMsg	endp


ThreadWB		proc
	LOCAL 		msg :MSG 
	
	invoke 		CoInitialize, NULL
	invoke 		CreateWBClass, hInstance

	invoke 		CreateWindowEx, 0, addr szClassNameWB, NULL,\ 
                WS_CHILD or WS_VISIBLE,\
	            0, 0, 800, 600, hWinMain, NULL, hInstance, NULL
	mov			hWBWin,eax
	invoke 		SendMessage, eax, WBM_NAVIGATE, 0, addr szUrl	

	.while TRUE
		invoke 	GetMessage, addr msg, 0, 0, 0 
	.break .if (!eax) 
		invoke 	TranslateMessage, addr msg 
		invoke 	DispatchMessage, addr msg 
	.endw 
	invoke		DestroyWindow,hWBWin
	;mov			eax, msg.wParam   
	xor			eax,eax
	ret

ThreadWB endp

end start